#[doc = "Register `PWR_PWRSYS_TRIM3` reader"]
pub struct R(crate::R<PWR_PWRSYS_TRIM3_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<PWR_PWRSYS_TRIM3_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<PWR_PWRSYS_TRIM3_SPEC>> for R {
    fn from(reader: crate::R<PWR_PWRSYS_TRIM3_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `PWR_PWRSYS_TRIM3` writer"]
pub struct W(crate::W<PWR_PWRSYS_TRIM3_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<PWR_PWRSYS_TRIM3_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<PWR_PWRSYS_TRIM3_SPEC>> for W {
    fn from(writer: crate::W<PWR_PWRSYS_TRIM3_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `NWELL_TRIM` reader - Vnwell (nwell regulator) trim?\\[0\\]: Vcchib + nhv(0.6V -1V)?\\[1\\]: Vcchib + nlowvt(0.4 -0.8V)?\\[2\\]: Vcchib + nhvnat(0.1-0.3)"]
pub struct NWELL_TRIM_R(crate::FieldReader<u8, u8>);
impl NWELL_TRIM_R {
    pub(crate) fn new(bits: u8) -> Self {
        NWELL_TRIM_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for NWELL_TRIM_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `NWELL_TRIM` writer - Vnwell (nwell regulator) trim?\\[0\\]: Vcchib + nhv(0.6V -1V)?\\[1\\]: Vcchib + nlowvt(0.4 -0.8V)?\\[2\\]: Vcchib + nhvnat(0.1-0.3)"]
pub struct NWELL_TRIM_W<'a> {
    w: &'a mut W,
}
impl<'a> NWELL_TRIM_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x07) | (value as u32 & 0x07);
        self.w
    }
}
#[doc = "Field `QUIET_TRIM` reader - Vccq (quiet regulator) trim"]
pub struct QUIET_TRIM_R(crate::FieldReader<u8, u8>);
impl QUIET_TRIM_R {
    pub(crate) fn new(bits: u8) -> Self {
        QUIET_TRIM_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for QUIET_TRIM_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `QUIET_TRIM` writer - Vccq (quiet regulator) trim"]
pub struct QUIET_TRIM_W<'a> {
    w: &'a mut W,
}
impl<'a> QUIET_TRIM_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x1f << 3)) | ((value as u32 & 0x1f) << 3);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:2 - Vnwell (nwell regulator) trim?\\[0\\]: Vcchib + nhv(0.6V -1V)?\\[1\\]: Vcchib + nlowvt(0.4 -0.8V)?\\[2\\]: Vcchib + nhvnat(0.1-0.3)"]
    #[inline(always)]
    pub fn nwell_trim(&self) -> NWELL_TRIM_R {
        NWELL_TRIM_R::new((self.bits & 0x07) as u8)
    }
    #[doc = "Bits 3:7 - Vccq (quiet regulator) trim"]
    #[inline(always)]
    pub fn quiet_trim(&self) -> QUIET_TRIM_R {
        QUIET_TRIM_R::new(((self.bits >> 3) & 0x1f) as u8)
    }
}
impl W {
    #[doc = "Bits 0:2 - Vnwell (nwell regulator) trim?\\[0\\]: Vcchib + nhv(0.6V -1V)?\\[1\\]: Vcchib + nlowvt(0.4 -0.8V)?\\[2\\]: Vcchib + nhvnat(0.1-0.3)"]
    #[inline(always)]
    pub fn nwell_trim(&mut self) -> NWELL_TRIM_W {
        NWELL_TRIM_W { w: self }
    }
    #[doc = "Bits 3:7 - Vccq (quiet regulator) trim"]
    #[inline(always)]
    pub fn quiet_trim(&mut self) -> QUIET_TRIM_W {
        QUIET_TRIM_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Power System Trim Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [pwr_pwrsys_trim3](index.html) module"]
pub struct PWR_PWRSYS_TRIM3_SPEC;
impl crate::RegisterSpec for PWR_PWRSYS_TRIM3_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [pwr_pwrsys_trim3::R](R) reader structure"]
impl crate::Readable for PWR_PWRSYS_TRIM3_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [pwr_pwrsys_trim3::W](W) writer structure"]
impl crate::Writable for PWR_PWRSYS_TRIM3_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets PWR_PWRSYS_TRIM3 to value 0"]
impl crate::Resettable for PWR_PWRSYS_TRIM3_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
